package com.getperka.cli.logging.model;
/**
   * Describes where a message originated from. In general, properties in this
   * class should be invariants that are useful for aggregation.
   */
@javax.annotation.Generated(value="org.jsonddl.generator.industrial.IndustrialDialect", date="2012-07-11T15:04:56")
public interface Source
    extends org.jsonddl.JsonDdlObject<Source>
 {
  /**
   * Constructs instances of {@link Source}. Instances of Builder should not be
   * reused after calling {@link #build()}.
   */
  @javax.annotation.Generated(value="org.jsonddl.generator.industrial.IndustrialDialect", date="2012-07-11T15:04:56")
  public static class Builder
      implements org.jsonddl.JsonDdlObject.Builder<Source>,  org.jsonddl.impl.Traversable<Source>, org.jsonddl.impl.Digested, Source {
    private Source built;
    private SourceImpl obj;
    public Builder() {
      this(new SourceImpl());
    }
    Builder(SourceImpl instance) {
      this.obj = instance;
    }
    public Source.Builder accept(org.jsonddl.JsonDdlVisitor visitor) {
      obj = new org.jsonddl.impl.ContextImpl.ObjectContext.Builder<Source>()
          .withValue(this)
          .withKind(org.jsonddl.model.Kind.DDL)
          .withMutability(true)
          .build().traverse(visitor).builder().obj;
      return this;
    }
    public Source build() {
      // Prevent build() loops from causing NPE's
      if (built != null) {
        return built;
      }
      SourceImpl toReturn = obj;
      built = toReturn;
      obj = null;
      return toReturn;
    }
    public Source.Builder builder() {
      return this;
    }
    public Source.Builder from(Source copyFrom) {
      withEnvironment(copyFrom.getEnvironment());
      withHostname(copyFrom.getHostname());
      withProcessName(copyFrom.getProcessName());
      withProcessUuid(copyFrom.getProcessUuid());
      return this;
    }
    public Source.Builder from(java.util.Map<String, Object> map) {
      accept(org.jsonddl.impl.JsonMapVisitor.fromJsonMap(map));
      return this;
    }
    public Class<Source> getDdlObjectType() {
      return Source.class;
    }
    public Source.Builder newInstance() {
      return new Source.Builder();
    }
    public java.util.Map<String, Object> toJsonObject() {
      return obj.toJsonObject();
    }
    public Source.Builder traverse(org.jsonddl.JsonDdlVisitor visitor) {
      withEnvironment(
      new org.jsonddl.impl.ContextImpl.ValueContext.Builder<java.lang.String>()
        .withKind(org.jsonddl.model.Kind.STRING)
        .withLeafType(java.lang.String.class)
        .withMutability(true)
        .withProperty("environment")
        .withValue(obj.Environment)
        .build().traverse(visitor));
      withHostname(
      new org.jsonddl.impl.ContextImpl.ValueContext.Builder<java.lang.String>()
        .withKind(org.jsonddl.model.Kind.STRING)
        .withLeafType(java.lang.String.class)
        .withMutability(true)
        .withProperty("hostname")
        .withValue(obj.Hostname)
        .build().traverse(visitor));
      withProcessName(
      new org.jsonddl.impl.ContextImpl.ValueContext.Builder<java.lang.String>()
        .withKind(org.jsonddl.model.Kind.STRING)
        .withLeafType(java.lang.String.class)
        .withMutability(true)
        .withProperty("processName")
        .withValue(obj.ProcessName)
        .build().traverse(visitor));
      withProcessUuid(
      new org.jsonddl.impl.ContextImpl.ValueContext.Builder<java.lang.String>()
        .withKind(org.jsonddl.model.Kind.STRING)
        .withLeafType(java.lang.String.class)
        .withMutability(true)
        .withProperty("processUuid")
        .withValue(obj.ProcessUuid)
        .build().traverse(visitor));
      return this;
    }
    public byte[] computeDigest() {
      byte[] digest;
      org.jsonddl.impl.DigestVisitor v = new org.jsonddl.impl.DigestVisitor();
      accept(v);
      digest = v.getDigest();
      return digest;
    }

    public int hashCode() {
      byte[] digest = computeDigest();
      return (int)((digest[0] << 3) | (digest[1] << 2) | (digest[18] << 1) | digest[19]);
    }

    public boolean equals(Object o) {
      if (o == this) {
        return true;
      }
      if (!(o instanceof org.jsonddl.impl.Digested)) {
        return false;
      }
      byte[] d1 = computeDigest();
      byte[] d2 = ((org.jsonddl.impl.Digested) o).computeDigest();
      for (int i = 0, j = d1.length; i<j; i++) {
        if (d1[i] != d2[i]) {
          return false;
        }
      }
      return true;
    }

    /**
     * For debugging use only.
     */
    public String toString() {
      return org.jsonddl.impl.JsonMapVisitor.toString(this);
    }
    public java.lang.String getEnvironment() {
      return obj.Environment;
    }

    public java.lang.String getHostname() {
      return obj.Hostname;
    }

    public java.lang.String getProcessName() {
      return obj.ProcessName;
    }

    public java.lang.String getProcessUuid() {
      return obj.ProcessUuid;
    }

    /** Describes the type of client that produced the message. */
    public void setEnvironment(java.lang.String value) {
      withEnvironment(value);
    }
    /** The unique host identifier */
    public void setHostname(java.lang.String value) {
      withHostname(value);
    }
    /** A human-readable name for the process. */
    public void setProcessName(java.lang.String value) {
      withProcessName(value);
    }
    /** A unique identifier to track all messages from a particular run. */
    public void setProcessUuid(java.lang.String value) {
      withProcessUuid(value);
    }
    /** Describes the type of client that produced the message. */
    public Source.Builder withEnvironment(java.lang.String value) {
      obj.Environment = value;
      return this;
    }
    /** The unique host identifier */
    public Source.Builder withHostname(java.lang.String value) {
      obj.Hostname = value;
      return this;
    }
    /** A human-readable name for the process. */
    public Source.Builder withProcessName(java.lang.String value) {
      obj.ProcessName = value;
      return this;
    }
    /** A unique identifier to track all messages from a particular run. */
    public Source.Builder withProcessUuid(java.lang.String value) {
      obj.ProcessUuid = value;
      return this;
    }
  }
  Builder builder();
  /** Describes the type of client that produced the message. */
  java.lang.String getEnvironment();
  /** The unique host identifier */
  java.lang.String getHostname();
  /** A human-readable name for the process. */
  java.lang.String getProcessName();
  /** A unique identifier to track all messages from a particular run. */
  java.lang.String getProcessUuid();
  Builder newInstance();
}